## cairo-dock 3.1.2.1

=== CMakeLists.txt ===
########### requirements ###############

cmake_minimum_required (VERSION 2.6)
find_package (PkgConfig)
include (CheckLibraryExists)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckSymbolExists)
include ("${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/GNUInstallDirs.cmake")

########### project ###############

project ("cairo-dock")
set (VERSION "3.1.2")

add_definitions (-std=c99 -Wall -Wextra) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds) # removed for stable versions: -Wstrict-prototypes #-Wunreachable-code -Wno-unused-parameter -Wall 
if (NOT ${CMAKE_BUILD_TYPE})
	add_definitions (-O3)
endif()
add_definitions (-DGL_GLEXT_PROTOTYPES="1")
add_definitions (-DCAIRO_DOCK_DEFAULT_ICON_NAME="default-icon.svg")
add_definitions (-DCAIRO_DOCK_ICON="cairo-dock.svg")
add_definitions (-DCAIRO_DOCK_LOGO="cairo-dock-logo.png")
add_definitions (-DCAIRO_DOCK_DATA_DIR="cairo-dock")
if (NOT "${force-icon-in-menus}" STREQUAL "no")  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=yes" is provided in the cmake command.
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=1)
else()
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=0)
endif()
add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

############ sources tarball ############

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
set (CPACK_SOURCE_IGNORE_FILES 
	"/build/;/.bzr/;bzrignore$;/config.h$;/gldi-config.h$;/doc/;/misc/;~$;/TODO$;${CPACK_SOURCE_IGNORE_FILES}")
include (CPack)

add_custom_target( dist
	COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
add_custom_target(dist-bzr
	COMMAND bzr export ${CMAKE_PROJECT_NAME}-${VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

########### global variables ###############

if( WIN32 )
	message(FATAL_ERROR "Cairo-Dock requires an air-conditioned room. Please close Windows!")
endif( WIN32 )

set (PACKAGE ${CMAKE_PROJECT_NAME})
set (GETTEXT_PACKAGE ${PACKAGE})

set (prefix ${CMAKE_INSTALL_PREFIX})  # /usr/local
set (exec_prefix ${prefix})
set (datadir "${prefix}/${CMAKE_INSTALL_DATAROOTDIR}")  # (...)/share
set (pkgdatadir "${datadir}/${CMAKE_PROJECT_NAME}")  # (...)/cairo-dock
set (mandir "${prefix}/${CMAKE_INSTALL_MANDIR}")  # (...)/man

set (VERSION_HELP "0.9.993") # needed to parse Help.conf.in

if( CMAKE_SIZEOF_VOID_P EQUAL 8 AND "${FORCE_LIB64}" STREQUAL "yes")  # 64bits and force install in lib64
	set (libdir "${prefix}/lib64")
elseif (NOT "${LIB_SUFFIX}" STREQUAL "")
	set (libdir "${prefix}/lib${LIB_SUFFIX}")  # (...)/libXX ## some distro use ${LIB_SUFFIX}
else()
	set (libdir "${prefix}/${CMAKE_INSTALL_LIBDIR}")  # (...)/lib or (...)/lib64 or custom ## GNU Install dir
endif()

set (includedir "${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")  # (...)/include
set (bindir "${prefix}/${CMAKE_INSTALL_BINDIR}")  # (...)/bin

########### dependencies ###############

set (packages_required "glib-2.0 gthread-2.0 cairo librsvg-2.0 dbus-1 dbus-glib-1 libxml-2.0 xrender gl glu pangox libcurl")  # for the .pc and to have details
STRING (REGEX REPLACE " " ";" packages_required_semicolon ${packages_required})  # replace blank space by semicolon => to have more details if a package is missing
pkg_check_modules ("PACKAGE" REQUIRED "${packages_required_semicolon}")

set (xextend_required "xtst xcomposite xinerama xrandr")  # for the .pc
STRING (REGEX REPLACE " " ";" xextend_required_semicolon ${xextend_required})
pkg_check_modules ("XEXTEND" "${xextend_required_semicolon}")

if (${XEXTEND_FOUND})
	set (HAVE_XEXTEND 1)
else()
	set (xextend_required)
endif()

if (NOT "${force-gtk2}" STREQUAL "yes")  # by default, we use GTK+3 except if we force the use of GTK+2
	set (gtk_required "gtk+-3.0")  # for the .pc
	pkg_check_modules ("GTK" "${gtk_required}")  # the check is not set as 'required' because we can use GTK+2 if GTK+3 isn't available
endif()

if (NOT "${GTK_FOUND}")
	set (gtk_required "gtk+-2.0")  # for the .pc
	pkg_check_modules ("GTK" REQUIRED "${gtk_required}")  # the check is requiered this time because we need GTK anyway.
endif()

STRING (REGEX REPLACE "\\..*" "" GTK_MAJOR "${GTK_VERSION}")

add_definitions (-DGTK_DISABLE_DEPRECATED="1")
# add_definitions (-DG_DISABLE_DEPRECATED="1")

# We use crypt(3) which may be in libc, or in libcrypt (eg FreeBSD)
check_library_exists (crypt encrypt "" HAVE_LIBCRYPT)
if (${HAVE_LIBCRYPT})
	set (LIBCRYPT_LIBS "-lcrypt")
endif()

check_symbol_exists (LC_MESSAGES "locale.h" HAVE_LC_MESSAGES)
check_include_files ("math.h" HAVE_MATH_H)
check_library_exists (m sin "" HAVE_LIBM)
if (NOT ${HAVE_LIBM} OR NOT ${HAVE_MATH_H})
	message(FATAL_ERROR "Cairo-Dock requires math.h")
endif()

check_include_files ("dlfcn.h" HAVE_DLFCN_H)
check_library_exists (dl dlopen "" HAVE_LIBDL)
if (NOT ${HAVE_LIBDL} OR NOT ${HAVE_DLFCN_H})
	message(FATAL_ERROR "Cairo-Dock requires dlfcn.h")
endif()

########### variables defined at compil time ###############

set (CAIRO_DOCK_SHARE_DATA_DIR ${pkgdatadir})
set (CAIRO_DOCK_SHARE_THEMES_DIR ${pkgdatadir}/themes)
#set (CAIRO_DOCK_MODULES_DIR ${libdir}/cairo-dock)
set (CAIRO_DOCK_LOCALE_DIR "${prefix}/${CMAKE_INSTALL_LOCALEDIR}")
set (CAIRO_DOCK_THEMES_DIR "themes")  # folder name where themes are saved locally, relatively to the root folder of Cairo-Dock.
set (CAIRO_DOCK_DISTANT_THEMES_DIR "themes3.1")  # folder name where themes are on the server, relatively to the root folder of the server files.
set (CAIRO_DOCK_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})

set (GLDI_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})
set (GLDI_SHARE_DATA_DIR ${pkgdatadir})
set (GLDI_MODULES_DIR ${libdir}/cairo-dock)
set (GLDI_BIN_DIR ${bindir})

########### next steps ###############

add_subdirectory (src)
add_subdirectory (data)
add_subdirectory (po)

########### file generation ###############

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake.in ${CMAKE_CURRENT_SOURCE_DIR}/src/config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.pc.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)

########### install files ###############

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc DESTINATION ${libdir}/pkgconfig)

################# Summary #################

MESSAGE (STATUS)
MESSAGE (STATUS "Cairo-Dock ${VERSION} will be compiled with the following options:")
if (${XEXTEND_FOUND})
	MESSAGE (STATUS " * Use X Extensions: Yes")
else()
	MESSAGE (STATUS " * Use X Extensions: No")
endif()
if (${HAVE_LIBCRYPT})
	MESSAGE (STATUS " * Crypt passwords : Yes")
else()
	MESSAGE (STATUS " * Crypt passwords : No")
endif()
MESSAGE (STATUS " * GTK version     : ${GTK_MAJOR} (${GTK_VERSION})")
MESSAGE (STATUS " * Installation in : ${prefix}")
MESSAGE (STATUS " * Lib directory   : ${libdir}")
MESSAGE (STATUS " * Themes directory: ${CAIRO_DOCK_DISTANT_THEMES_DIR}")
MESSAGE (STATUS)

=== src/CMakeLists.txt ===

add_subdirectory (icon-factory)
add_subdirectory (gldit)
add_subdirectory (implementations)
add_subdirectory (help)

SET(cairo_dock_SRCS
	cairo-dock.c
	cairo-dock-menu.c 					cairo-dock-menu.h 
	cairo-dock-user-interaction.c 		cairo-dock-user-interaction.h 
	cairo-dock-gui-advanced.c 			cairo-dock-gui-advanced.h
	cairo-dock-gui-simple.c 			cairo-dock-gui-simple.h
	cairo-dock-gui-backend.c 			cairo-dock-gui-backend.h
	cairo-dock-gui-commons.c 			cairo-dock-gui-commons.h
	cairo-dock-widget.c 				cairo-dock-widget.h
	cairo-dock-widget-themes.c 			cairo-dock-widget-themes.h
	cairo-dock-widget-items.c 			cairo-dock-widget-items.h
	cairo-dock-widget-config.c 			cairo-dock-widget-config.h
	cairo-dock-widget-plugins.c 		cairo-dock-widget-plugins.h
	cairo-dock-widget-module.c			cairo-dock-widget-module.h
	cairo-dock-widget-config-group.c 	cairo-dock-widget-config-group.h
	cairo-dock-widget-shortkeys.c		cairo-dock-widget-shortkeys.h
)

########### compilation ###############

# Make sure the compiler can find include files from the libraries.
include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${XEXTEND_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

# Make sure the linker can find the libraries.
link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${XEXTEND_LIBRARY_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/help)

# Add executable that is built from the source files.
add_executable (${PROJECT_NAME}
	${cairo_dock_SRCS} )

# Link the executable to the librairies.
target_link_libraries (${PROJECT_NAME}
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES}
	${XEXTEND_LIBRARIES}
	${LIBCRYPT_LIBS}
	gldi
	icon-factory
	implementations
	help)

# install the program once it is built.
install(
	TARGETS ${PACKAGE}
	DESTINATION bin)

=== data/themes/default-theme-panel/plug-ins/CMakeLists.txt ===
add_subdirectory(AlsaMixer)
add_subdirectory(Animated-icons)
add_subdirectory(Calendar)
add_subdirectory(Clipper)
add_subdirectory(clock)
add_subdirectory(dialog-rendering)
add_subdirectory(dnd2share)
add_subdirectory(drop_indicator)
add_subdirectory(GMenu)
add_subdirectory(Help)
add_subdirectory(icon-effect)
add_subdirectory(illusion)
add_subdirectory(logout)
add_subdirectory(Messaging-Menu)
add_subdirectory(musicPlayer)
add_subdirectory(netspeed)
add_subdirectory(powermanager)
add_subdirectory(Printers-Menu)
add_subdirectory(quick-browser)
add_subdirectory(Recent-Events)
add_subdirectory(rendering)
add_subdirectory(shortcuts)
add_subdirectory(showDesktop)
add_subdirectory(Status-Notifier)
add_subdirectory(switcher)

=== data/themes/default-theme-panel/plug-ins/Printers-Menu/CMakeLists.txt ===
install (FILES Printers-Menu.conf DESTINATION ${pkgdatadir}/themes/Default-Panel/plug-ins/Printers-Menu )

=== debian/changelog ===
cairo-dock (3.1.2.1-0ubuntu1) raring; urgency=low

  * New upstream release. (bug-fix version)
  * Detailed Upstream ChangeLog:
    - Dialogues Mgr:
      + cairo_dock_set_dialog_message (used by Help): used markup if it's
        needed
      + Fixed 2 bugs when an icon holding a modal dialog is destroyed 
    - GUI:
      + Search for an icon path if the module gives us only the name of its
        icon (e.g. Deluge, Transmission, Menus)
      + Simple: Behavior: Position of the taskbar: 'After a given icon'
        choise was missing 
    - Icon Mgr: removed a now useless static mutex
    - Init:
      + Initialised threads on new versions of GLib (>= 2.24)
      + This should finally fix a crash when opening Logout menu 
    - Help: Used markup for the dialogues
    - Menu: Quit with a Cairo-Dock session: check if it's really the shift key
      which is used to unlock the quit menu entry 
  * debian/control: bumped cairo-dock-plug-ins* versions

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Thu, 06 Dec 2012 18:51:36 +0100

cairo-dock (3.1.1-0ubuntu1) raring; urgency=low

  * New upstream release. (bug-fix version)
  * Detailed Upstream Changelog:
    - Dialogues Mgr: Rewrite blocking dialogue to avoid bug with 'terminal'
      applet
    - GUI
      + Simple:
        + Used the right translation for titles of all main categories and
          description of views
        + With old versions of GTK2 (< 2.22, e.g. on Debian stable or Ubuntu
          Lucid): this config panel had tabs but without any widget inside 
      + Advanced:
        + Widget Items: Invisible modules: displayed the title (which is
          translated) 
    - Icon Mgr:
      + Fixed a crash with the icons theme when it is reloaded
      + Icon was invisible for launchers that are pinned to a given desktop
      + Icons were not correctly sorted (it impacted Shortcuts) 
    - Init: Used dbus_g_thread_init before 'gtk_init' in order to be called
      before the first use of DBus
      + It should fixed a "random" crash when clicking on logout applet. 
    - Help: always check the composite on startup, until the user choose not to
    - Theme: Panel:
      + Added Printers-Menu.conf file (needed to place this applet at the
        right position)
      + Dnd2share: used the new 'busy' animation 
    - Misc.:
      + Compilation libdir: some distro (e.g. Gentoo) use LIB_SUFFIX flag:
        used a specific case for that
      + Updated translations 
  * debian/patches/bzr_translate_titles_of_categories_and_readme.patch:
    - Removed: Now in upstream
  * debian/control:
    - Forced the use of the same version of libgldi3

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Sat, 10 Nov 2012 23:52:14 +0100

=== debian/control ===
Source: cairo-dock
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthieu Baerts (matttbe) <matttbe@ubuntu.com>, Julien Lavergne <julien.lavergne@gmail.com>, Fabrice Rey <fabounet@glx-dock.org>
Build-Depends: cdbs,
               cmake,
               debhelper (>= 8.1.3),
               libcairo2-dev,
               libcurl4-gnutls-dev,
               libdbus-glib-1-dev,
               libgl1-mesa-dev | libgl-dev,
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk-3-dev,
               libpango1.0-dev,
               librsvg2-dev,
               libxcomposite-dev,
               libxinerama-dev,
               libxml2-dev,
               libxrender-dev,
               libxtst-dev
Standards-Version: 3.9.3
Homepage: http://www.glx-dock.org/

Package: cairo-dock
Section: graphics
Architecture: all
Conflicts: cairo-dock (<= 2.0.8.0)
Depends: cairo-dock-core (>= ${source:Version}),
         cairo-dock-plug-ins (>= 3.1.2),
         cairo-dock-plug-ins-dbus-interface-python (>= 3.1.2),
         cairo-dock-plug-ins-integration (>= 3.1.2),
         ${misc:Depends}
Description: Light and eye-candy dock to launch your programs (metapackage)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This metapackage provides the components necessary for running Cairo-Dock. It
 provides the Cairo-Dock core, a set of standard plugins and the files necessary
 to integrate Cairo-Dock with your desktop environment.

Package: cairo-dock-core
Section: graphics
Architecture: any
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0)
Depends: cairo-dock-data (>= ${source:Version}),
         libgldi3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: cairo-dock,
            cairo-dock-plug-ins,
            compiz-plugins | e17 | kde-window-manager | openbox | xfwm4
Suggests: compiz-plugins, gnome-session
Description: Light and eye-candy dock to launch your programs (core package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package is the core of Cairo-Dock project.

Package: libgldi-dev
Section: libdevel
Architecture: any
Depends: libcairo2-dev,
         libcurl4-gnutls-dev,
         libdbus-glib-1-dev,
         libgl1-mesa-dev | libgl-dev,
         libgldi3 (= ${binary:Version}),
         libglib2.0-dev,
         libglu1-mesa-dev | libglu-dev,
         libgtk-3-dev,
         libpango1.0-dev,
         librsvg2-dev,
         libxcomposite-dev,
         libxinerama-dev,
         libxml2-dev,
         libxrender-dev,
         libxtst-dev,
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: cairo-dock
Multi-Arch: same
Description: Light and eye-candy dock to launch your programs (dev package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package provides the include files and static library for cairo-dock
 functions.

Package: cairo-dock-data
Section: graphics
Architecture: all
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0)
Depends: ${misc:Depends}
Description: Light and eye-candy dock to launch your programs (common files)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package contains default icons and themes for Cairo-Dock.

Package: libgldi3
Section: graphics
Architecture: any
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0), cairo-dock-core (<< 3.0.0)
Breaks: cairo-dock-core (<< 3.0.0)
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: cairo-dock-data (>= ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Light and eye-candy dock to launch your programs (lib package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package contains the library created and used by the Cairo-Dock project.

## cairo-dock 3.1.99.rc2.1~20130304~bzr1411

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 ########### project ###############
 
 project ("cairo-dock")
-set (VERSION "3.1.2")
+set (VERSION "3.1.99.rc2")
 
 add_definitions (-std=c99 -Wall -Wextra) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds) # removed for stable versions: -Wstrict-prototypes #-Wunreachable-code -Wno-unused-parameter -Wall 
 if (NOT ${CMAKE_BUILD_TYPE})
@@ -22,12 +22,25 @@
 add_definitions (-DCAIRO_DOCK_ICON="cairo-dock.svg")
 add_definitions (-DCAIRO_DOCK_LOGO="cairo-dock-logo.png")
 add_definitions (-DCAIRO_DOCK_DATA_DIR="cairo-dock")
-if (NOT "${force-icon-in-menus}" STREQUAL "no")  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=yes" is provided in the cmake command.
+add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
+
+
+###########     Misc     ###############
+macro (enable_if_not_defined MODULE1)
+	if (NOT DEFINED MODULE1) # true if not defined
+		set (${MODULE1} TRUE)
+	endif ()
+endmacro (enable_if_not_defined)
+
+
+##########     Config    ###############
+
+enable_if_not_defined (force-icon-in-menus)
+if (force-icon-in-menus)  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=yes" is provided in the cmake command.
 	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=1)
 else()
 	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=0)
 endif()
-add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
 
 ############ sources tarball ############
 
@@ -58,9 +71,7 @@
 set (pkgdatadir "${datadir}/${CMAKE_PROJECT_NAME}")  # (...)/cairo-dock
 set (mandir "${prefix}/${CMAKE_INSTALL_MANDIR}")  # (...)/man
 
-set (VERSION_HELP "0.9.993") # needed to parse Help.conf.in
-
-if( CMAKE_SIZEOF_VOID_P EQUAL 8 AND "${FORCE_LIB64}" STREQUAL "yes")  # 64bits and force install in lib64
+if( CMAKE_SIZEOF_VOID_P EQUAL 8 AND (force-lib64 OR "${FORCE_LIB64}" STREQUAL "yes"))  # 64bits and force install in lib64
 	set (libdir "${prefix}/lib64")
 elseif (NOT "${LIB_SUFFIX}" STREQUAL "")
 	set (libdir "${prefix}/lib${LIB_SUFFIX}")  # (...)/libXX ## some distro use ${LIB_SUFFIX}
@@ -71,28 +82,44 @@
 set (includedir "${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")  # (...)/include
 set (bindir "${prefix}/${CMAKE_INSTALL_BINDIR}")  # (...)/bin
 
+set (pluginsdir "${libdir}/cairo-dock")
+set (pluginsdatadir "${pkgdatadir}/plug-ins")
+if (NOT DEFINED install-pc-path)
+	set (install-pc-path "${libdir}/pkgconfig")  # it can be different (for example ${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig on BSD)
+endif ()
+
 ########### dependencies ###############
 
 set (packages_required "glib-2.0 gthread-2.0 cairo librsvg-2.0 dbus-1 dbus-glib-1 libxml-2.0 xrender gl glu pangox libcurl")  # for the .pc and to have details
 STRING (REGEX REPLACE " " ";" packages_required_semicolon ${packages_required})  # replace blank space by semicolon => to have more details if a package is missing
 pkg_check_modules ("PACKAGE" REQUIRED "${packages_required_semicolon}")
 
-set (xextend_required "xtst xcomposite xinerama xrandr")  # for the .pc
-STRING (REGEX REPLACE " " ";" xextend_required_semicolon ${xextend_required})
-pkg_check_modules ("XEXTEND" "${xextend_required_semicolon}")
-
-if (${XEXTEND_FOUND})
-	set (HAVE_XEXTEND 1)
-else()
-	set (xextend_required)
-endif()
-
-if (NOT "${force-gtk2}" STREQUAL "yes")  # by default, we use GTK+3 except if we force the use of GTK+2
+set (with_xentend no)
+enable_if_not_defined (enable-x11-ext-support) # enabled by default
+if (enable-x11-ext-support)
+	set (xextend_required "xtst xcomposite xrandr")  # for the .pc
+	STRING (REGEX REPLACE " " ";" xextend_required_semicolon ${xextend_required})
+	pkg_check_modules ("XEXTEND" "${xextend_required_semicolon}")
+	
+	if (XEXTEND_FOUND)
+		set (HAVE_XEXTEND 1)
+		set (with_xentend yes)
+		
+		pkg_check_modules ("XINERAMA" "xinerama")  # check for Xinerama separately, since is now replaced by Xrandr >= 1.3
+		if (XINERAMA_FOUND)
+			set (HAVE_XINERAMA 1)
+		endif()
+	else()
+		set (xextend_required)
+	endif()
+endif()
+
+if (NOT force-gtk2)  # by default, we use GTK+3 except if we force the use of GTK+2
 	set (gtk_required "gtk+-3.0")  # for the .pc
 	pkg_check_modules ("GTK" "${gtk_required}")  # the check is not set as 'required' because we can use GTK+2 if GTK+3 isn't available
 endif()
 
-if (NOT "${GTK_FOUND}")
+if (NOT GTK_FOUND)
 	set (gtk_required "gtk+-2.0")  # for the .pc
 	pkg_check_modules ("GTK" REQUIRED "${gtk_required}")  # the check is requiered this time because we need GTK anyway.
 endif()
@@ -104,20 +131,20 @@
 
 # We use crypt(3) which may be in libc, or in libcrypt (eg FreeBSD)
 check_library_exists (crypt encrypt "" HAVE_LIBCRYPT)
-if (${HAVE_LIBCRYPT})
+if (HAVE_LIBCRYPT)
 	set (LIBCRYPT_LIBS "-lcrypt")
 endif()
 
 check_symbol_exists (LC_MESSAGES "locale.h" HAVE_LC_MESSAGES)
 check_include_files ("math.h" HAVE_MATH_H)
 check_library_exists (m sin "" HAVE_LIBM)
-if (NOT ${HAVE_LIBM} OR NOT ${HAVE_MATH_H})
+if (NOT HAVE_LIBM OR NOT HAVE_MATH_H)
 	message(FATAL_ERROR "Cairo-Dock requires math.h")
 endif()
 
 check_include_files ("dlfcn.h" HAVE_DLFCN_H)
 check_library_exists (dl dlopen "" HAVE_LIBDL)
-if (NOT ${HAVE_LIBDL} OR NOT ${HAVE_DLFCN_H})
+if (NOT HAVE_LIBDL OR NOT HAVE_DLFCN_H)
 	message(FATAL_ERROR "Cairo-Dock requires dlfcn.h")
 endif()
 
@@ -133,7 +160,7 @@
 
 set (GLDI_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})
 set (GLDI_SHARE_DATA_DIR ${pkgdatadir})
-set (GLDI_MODULES_DIR ${libdir}/cairo-dock)
+set (GLDI_MODULES_DIR ${pluginsdir})
 set (GLDI_BIN_DIR ${bindir})
 
 ########### next steps ###############
@@ -141,6 +168,17 @@
 add_subdirectory (src)
 add_subdirectory (data)
 add_subdirectory (po)
+
+############# HELP #################
+# this is actually a plug-in for cairo-dock, not for gldi
+# it uses some functions of cairo-dock (they are binded dynamically), that's why it can't go with other plug-ins
+set (GETTEXT_HELP ${GETTEXT_PACKAGE})
+set (VERSION_HELP "0.9.994")
+set (PACKAGE_HELP "cd-Help")
+set (helpdatadir "${pluginsdatadir}/Help")
+set (dock_version "${VERSION}")
+configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Help/data/Help.conf.in ${CMAKE_CURRENT_BINARY_DIR}/Help/data/Help.conf)
+add_subdirectory (Help)
 
 ########### file generation ###############
 
@@ -151,24 +189,31 @@
 
 ########### install files ###############
 
-install (FILES ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc DESTINATION ${libdir}/pkgconfig)
+install (FILES ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc DESTINATION ${install-pc-path})
 
 ################# Summary #################
 
 MESSAGE (STATUS)
 MESSAGE (STATUS "Cairo-Dock ${VERSION} will be compiled with the following options:")
-if (${XEXTEND_FOUND})
+if (XEXTEND_FOUND)
 	MESSAGE (STATUS " * Use X Extensions: Yes")
 else()
 	MESSAGE (STATUS " * Use X Extensions: No")
 endif()
-if (${HAVE_LIBCRYPT})
+if (HAVE_LIBCRYPT)
 	MESSAGE (STATUS " * Crypt passwords : Yes")
 else()
 	MESSAGE (STATUS " * Crypt passwords : No")
 endif()
-MESSAGE (STATUS " * GTK version     : ${GTK_MAJOR} (${GTK_VERSION})")
-MESSAGE (STATUS " * Installation in : ${prefix}")
-MESSAGE (STATUS " * Lib directory   : ${libdir}")
-MESSAGE (STATUS " * Themes directory: ${CAIRO_DOCK_DISTANT_THEMES_DIR}")
+MESSAGE (STATUS " * GTK version       : ${GTK_MAJOR} (${GTK_VERSION})")
+MESSAGE (STATUS " * Installation in   : ${prefix}")
+MESSAGE (STATUS " * Lib directory     : ${libdir}")
+MESSAGE (STATUS " * With X11 ext.     : ${with_xentend} (${xextend_required})")
+MESSAGE (STATUS " * Themes directory  : ${CAIRO_DOCK_DISTANT_THEMES_DIR}")
+if (enable-desktop-manager)
+	set (with_cd_session yes)
+else()
+	set (cd-with_cd_session no)
+endif()
+MESSAGE (STATUS " * Cairo-dock session: ${with_cd_session}")
 MESSAGE (STATUS)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,6 @@
 add_subdirectory (icon-factory)
 add_subdirectory (gldit)
 add_subdirectory (implementations)
-add_subdirectory (help)
 
 SET(cairo_dock_SRCS
 	cairo-dock.c
@@ -28,19 +27,14 @@
 include_directories(
 	${PACKAGE_INCLUDE_DIRS}
 	${GTK_INCLUDE_DIRS}
-	${XEXTEND_INCLUDE_DIRS}
-	${CMAKE_SOURCE_DIR}/src
 	${CMAKE_SOURCE_DIR}/src/gldit
-	${CMAKE_SOURCE_DIR}/src/icon-factory
-	${CMAKE_SOURCE_DIR}/src/implementations)
+	${CMAKE_SOURCE_DIR}/src/icon-factory)
 
 # Make sure the linker can find the libraries.
 link_directories(
 	${PACKAGE_LIBRARY_DIRS}
 	${GTK_LIBRARY_DIRS}
-	${XEXTEND_LIBRARY_DIRS}
-	${CMAKE_SOURCE_DIR}/src/gldit
-	${CMAKE_SOURCE_DIR}/src/help)
+	${CMAKE_SOURCE_DIR}/src/gldit)
 
 # Add executable that is built from the source files.
 add_executable (${PROJECT_NAME}
@@ -50,12 +44,8 @@
 target_link_libraries (${PROJECT_NAME}
 	${PACKAGE_LIBRARIES}
 	${GTK_LIBRARIES}
-	${XEXTEND_LIBRARIES}
-	${LIBCRYPT_LIBS}
 	gldi
-	icon-factory
-	implementations
-	help)
+	icon-factory)
 
 # install the program once it is built.
 install(

=== Help/src/CMakeLists.txt ===

########### sources ###############

SET(MODULE_SRCS
	applet-struct.h
	applet-init.c 			applet-init.h
	applet-config.c 			applet-config.h
	applet-notifications.c 		applet-notifications.h
	applet-tips-dialog.c 		applet-tips-dialog.h
	applet-composite.c 		applet-composite.h
)

add_library(${PACKAGE_HELP} SHARED ${MODULE_SRCS})

########### compil ###############
add_definitions (-DMY_APPLET_SHARE_DATA_DIR="${helpdatadir}")
add_definitions (-DMY_APPLET_PREVIEW_FILE="preview.jpg")
add_definitions (-DMY_APPLET_CONF_FILE="Help.conf")
add_definitions (-DMY_APPLET_USER_DATA_DIR="Help")
add_definitions (-DMY_APPLET_VERSION="${VERSION_HELP}")
add_definitions (-DMY_APPLET_GETTEXT_DOMAIN="${GETTEXT_HELP}")
add_definitions (-DMY_APPLET_DOCK_VERSION="${dock_version}")
add_definitions (-DMY_APPLET_ICON_FILE="icon.svg")
### uncomment the following line to allow multi-instance applet.
#add_definitions (-DCD_APPLET_MULTI_INSTANCE="1")
### uncomment the following line to allow extended OpenGL drawing.
#add_definitions (-DGL_GLEXT_PROTOTYPES="1")

include_directories (
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

link_directories (
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS})

target_link_libraries (${PACKAGE_HELP}
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES})

########### install files ###############

install(TARGETS ${PACKAGE_HELP} DESTINATION ${pluginsdir})

=== src/gldit/CMakeLists.txt ===

SET(core_lib_SRCS
	cairo-dock-struct.h
	cairo-dock-global-variables.h 
	cairo-dock-core.c 					cairo-dock-core.h
	cairo-dock-manager.c 				cairo-dock-manager.h
	cairo-dock-object.c 				cairo-dock-object.h
	# icons
	cairo-dock-icon-manager.c 			cairo-dock-icon-manager.h
	cairo-dock-icon-factory.c 			cairo-dock-icon-factory.h
	cairo-dock-icon-facility.c 			cairo-dock-icon-facility.h
	cairo-dock-indicator-manager.c 		cairo-dock-indicator-manager.h
	cairo-dock-applications-manager.c 	cairo-dock-applications-manager.h 
	cairo-dock-application-facility.c 	cairo-dock-application-facility.h
	cairo-dock-launcher-manager.c 		cairo-dock-launcher-manager.h
	cairo-dock-applet-manager.c 		cairo-dock-applet-manager.h
	cairo-dock-applet-facility.c 		cairo-dock-applet-facility.h
	cairo-dock-separator-manager.c 		cairo-dock-separator-manager.h
	cairo-dock-module-factory.c 		cairo-dock-module-factory.h
	cairo-dock-module-manager.c 		cairo-dock-module-manager.h
	# containers
	cairo-dock-container.c 				cairo-dock-container.h
	cairo-dock-desklet-manager.c 		cairo-dock-desklet-manager.h
	cairo-dock-desklet-factory.c 		cairo-dock-desklet-factory.h
	cairo-dock-dialog-factory.c 		cairo-dock-dialog-factory.h
	cairo-dock-dialog-manager.c 		cairo-dock-dialog-manager.h
	cairo-dock-flying-container.c 		cairo-dock-flying-container.h
	cairo-dock-dock-manager.c 			cairo-dock-dock-manager.h
	cairo-dock-dock-factory.c 			cairo-dock-dock-factory.h
	cairo-dock-dock-facility.c 			cairo-dock-dock-facility.h
	cairo-dock-callbacks.c 				cairo-dock-callbacks.h 
	cairo-dock-animations.c 			cairo-dock-animations.h
	cairo-dock-notifications.c 			cairo-dock-notifications.h
	cairo-dock-backends-manager.c 		cairo-dock-backends-manager.h
	cairo-dock-data-renderer.c 			cairo-dock-data-renderer.h
	cairo-dock-data-renderer-manager.c 		cairo-dock-data-renderer-manager.h
	cairo-dock-file-manager.c 			cairo-dock-file-manager.h
	cairo-dock-themes-manager.c 		cairo-dock-themes-manager.h
	cairo-dock-class-manager.c 			cairo-dock-class-manager.h
	cairo-dock-X-manager.c 				cairo-dock-X-manager.h
	cairo-dock-image-buffer.c			cairo-dock-image-buffer.h 
	cairo-dock-opengl.c 				cairo-dock-opengl.h
	cairo-dock-opengl-path.c 			cairo-dock-opengl-path.h
	cairo-dock-opengl-font.c 			cairo-dock-opengl-font.h
	cairo-dock-surface-factory.c 		cairo-dock-surface-factory.h
	cairo-dock-draw.c 					cairo-dock-draw.h 
	cairo-dock-draw-opengl.c 			cairo-dock-draw-opengl.h
	# utilities
	cairo-dock-log.c 					cairo-dock-log.h
	cairo-dock-gui-manager.c 			cairo-dock-gui-manager.h
	cairo-dock-gui-factory.c 			cairo-dock-gui-factory.h
	eggaccelerators.c 					eggaccelerators.h
	cairo-dock-keybinder.c 				cairo-dock-keybinder.h
	cairo-dock-dbus.c 					cairo-dock-dbus.h 
	cairo-dock-X-utilities.c 			cairo-dock-X-utilities.h
	cairo-dock-keyfile-utilities.c 		cairo-dock-keyfile-utilities.h
	cairo-dock-packages.c 				cairo-dock-packages.h
	cairo-dock-particle-system.c 		cairo-dock-particle-system.h
	cairo-dock-overlay.c 				cairo-dock-overlay.h
	cairo-dock-task.c 					cairo-dock-task.h
	cairo-dock-config.c 				cairo-dock-config.h 
	texture-gradation.h
	texture-blur.h
)


########### compilation ###############

# Make sure the compiler can find include files from the libraries.
include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${XEXTEND_INCLUDE_DIRS}
	${XINERAMA_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

# Make sure the linker can find the libraries.
link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${XEXTEND_LIBRARY_DIRS}
	${XINERAMA_LIBRARY_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

# Define the library
add_library ("gldi" SHARED ${core_lib_SRCS})
STRING (REGEX REPLACE "\\..*" "" SOVERSION "${VERSION}")
set_target_properties ("gldi" PROPERTIES
	# create *nix style library versions + symbolic links
	VERSION ${VERSION}
	SOVERSION ${SOVERSION}
	# allow creating static and shared libs without conflicts
	#CLEAN_DIRECT_OUTPUT 1
	# avoid conflicts between library and binary target names
	#OUTPUT_NAME ${PROJECT_NAME}
)

# Link the result to the librairies.
target_link_libraries("gldi"
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES}
	${XEXTEND_LIBRARIES}
	${XINERAMA_LIBRARIES}
	${LIBCRYPT_LIBS}
	icon-factory
	implementations
	dl)


configure_file (${CMAKE_CURRENT_SOURCE_DIR}/gldi.pc.in ${CMAKE_CURRENT_BINARY_DIR}/gldi.pc)
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/gldi.pc DESTINATION ${install-pc-path})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so DESTINATION ${libdir})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so.${VERSION} DESTINATION ${libdir})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so.${SOVERSION} DESTINATION ${libdir})

########### install files ###############

install(FILES cairo-dock.h DESTINATION ${includedir}/cairo-dock)
install(FILES
	cairo-dock-struct.h 			cairo-dock-global-variables.h
	gldi-config.h
	cairo-dock-core.h			cairo-dock-manager.h
	cairo-dock-object.h
	cairo-dock-icon-factory.h		cairo-dock-icon-manager.h
	cairo-dock-icon-facility.h
	cairo-dock-applications-manager.h 	cairo-dock-launcher-manager.h
	cairo-dock-separator-manager.h 		cairo-dock-applet-manager.h
	cairo-dock-backends-manager.h		cairo-dock-notifications.h
	
	cairo-dock-packages.h
	cairo-dock-data-renderer.h
	cairo-dock-data-renderer-manager.h
	cairo-dock-dock-manager.h		
	cairo-dock-desklet-manager.h
	cairo-dock-dialog-manager.h
	cairo-dock-indicator-manager.h
	cairo-dock-themes-manager.h
	cairo-dock-gui-manager.h
	cairo-dock-file-manager.h
	cairo-dock-X-manager.h
	cairo-dock-class-manager.h
	cairo-dock-opengl.h
	cairo-dock-image-buffer.h
	cairo-dock-config.h
	cairo-dock-module-factory.h
	cairo-dock-module-manager.h
	cairo-dock-container.h
	cairo-dock-dock-factory.h			cairo-dock-callbacks.h
	cairo-dock-desklet-factory.h
	cairo-dock-dialog-factory.h
	cairo-dock-flying-container.h
	
	cairo-dock-applet-multi-instance.h 	cairo-dock-applet-single-instance.h
	cairo-dock-applet-canvas.h			cairo-dock-applet-facility.h
	
	cairo-dock-draw.h					cairo-dock-draw-opengl.h
	cairo-dock-opengl-path.h 			cairo-dock-opengl-font.h 
	cairo-dock-particle-system.h		cairo-dock-overlay.h
	cairo-dock-X-utilities.h			cairo-dock-dbus.h
	cairo-dock-keyfile-utilities.h		cairo-dock-surface-factory.h
	cairo-dock-log.h					cairo-dock-keybinder.h
	cairo-dock-application-facility.h	cairo-dock-dock-facility.h
	cairo-dock-task.h
	cairo-dock-animations.h
	cairo-dock-gui-factory.h
	
	DESTINATION ${includedir}/cairo-dock/gldit)

if (disable-gtk-grip)
	add_definitions (-DENABLE_GTK_GRIP=1)
endif()

=== debian/changelog ===
cairo-dock (3.1.99.rc2.1~20130304~bzr1411-0ubuntu1) raring; urgency=low

  * New upstream snapshot.
  * Short Upstream ChangeLog:
    - Multi-screen support has been improved
    - Added Systemd support for the session management
    - Countless bug-fixes and improvements
  * debian/rules:
    - Removed useless flag (was needed for GTK2)
  * debian/control:
    - XRandr is now used by default instead of Xinerama
    - Bumped Cairo-Dock Plug-Ins versions
  * debian/cairo-dock-core.install:
    - Added all libcd*.so: the 'Help' is now in a separated file.

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Mon, 04 Mar 2013 23:51:02 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libpango1.0-dev,
                librsvg2-dev,
                libxcomposite-dev,
-               libxinerama-dev,
+               libxrandr-dev,
                libxml2-dev,
                libxrender-dev,
                libxtst-dev
@@ -28,9 +28,9 @@
 Architecture: all
 Conflicts: cairo-dock (<= 2.0.8.0)
 Depends: cairo-dock-core (>= ${source:Version}),
-         cairo-dock-plug-ins (>= 3.1.2),
-         cairo-dock-plug-ins-dbus-interface-python (>= 3.1.2),
-         cairo-dock-plug-ins-integration (>= 3.1.2),
+         cairo-dock-plug-ins (>= 3.1.98),
+         cairo-dock-plug-ins-dbus-interface-python (>= 3.1.98),
+         cairo-dock-plug-ins-integration (>= 3.1.98),
          ${misc:Depends}
 Description: Light and eye-candy dock to launch your programs (metapackage)
  Cairo-Dock is a pretty, light and convenient interface to your desktop,
@@ -89,7 +89,7 @@
          libpango1.0-dev,
          librsvg2-dev,
          libxcomposite-dev,
-         libxinerama-dev,
+         libxrandr-dev,
          libxml2-dev,
          libxrender-dev,
          libxtst-dev,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DH_ALWAYS_EXCLUDE=CVS:.bzr

DEB_CMAKE_EXTRA_FLAGS += -Denable-desktop-manager=yes \
	-DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_INSTALL_CHANGELOGS_ALL := ChangeLog

get-orig-source:
	dh_testdir
	uscan --force-download --verbose --repack

## cairo-dock 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 ########### project ###############
 
 project ("cairo-dock")
-set (VERSION "3.1.99.rc2")
+set (VERSION "3.2.0")
 
 add_definitions (-std=c99 -Wall -Wextra) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds) # removed for stable versions: -Wstrict-prototypes #-Wunreachable-code -Wno-unused-parameter -Wall 
 if (NOT ${CMAKE_BUILD_TYPE})
@@ -90,7 +90,7 @@
 
 ########### dependencies ###############
 
-set (packages_required "glib-2.0 gthread-2.0 cairo librsvg-2.0 dbus-1 dbus-glib-1 libxml-2.0 xrender gl glu pangox libcurl")  # for the .pc and to have details
+set (packages_required "glib-2.0 gthread-2.0 cairo librsvg-2.0 dbus-1 dbus-glib-1 libxml-2.0 xrender gl glu libcurl")  # for the .pc and to have details
 STRING (REGEX REPLACE " " ";" packages_required_semicolon ${packages_required})  # replace blank space by semicolon => to have more details if a package is missing
 pkg_check_modules ("PACKAGE" REQUIRED "${packages_required_semicolon}")
 
@@ -144,9 +144,18 @@
 
 check_include_files ("dlfcn.h" HAVE_DLFCN_H)
 check_library_exists (dl dlopen "" HAVE_LIBDL)
-if (NOT HAVE_LIBDL OR NOT HAVE_DLFCN_H)
+if (HAVE_LIBDL)  # dlopen might be in libc directly as in FreeBSD
+	set (LIBDL_LIBRARIES "dl")
+endif()
+if (NOT HAVE_DLFCN_H)
 	message(FATAL_ERROR "Cairo-Dock requires dlfcn.h")
 endif()
+
+check_library_exists (intl libintl_gettext "" HAVE_LIBINTL)
+if (HAVE_LIBINTL)  # on BSD, we have to link to libintl to be able to use gettext.
+	set (LIBINTL_LIBRARIES "intl")
+endif()
+
 
 ########### variables defined at compil time ###############
 
@@ -155,7 +164,7 @@
 #set (CAIRO_DOCK_MODULES_DIR ${libdir}/cairo-dock)
 set (CAIRO_DOCK_LOCALE_DIR "${prefix}/${CMAKE_INSTALL_LOCALEDIR}")
 set (CAIRO_DOCK_THEMES_DIR "themes")  # folder name where themes are saved locally, relatively to the root folder of Cairo-Dock.
-set (CAIRO_DOCK_DISTANT_THEMES_DIR "themes3.1")  # folder name where themes are on the server, relatively to the root folder of the server files.
+set (CAIRO_DOCK_DISTANT_THEMES_DIR "themes3.2")  # folder name where themes are on the server, relatively to the root folder of the server files.
 set (CAIRO_DOCK_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})
 
 set (GLDI_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})
@@ -184,6 +193,7 @@
 
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake.in ${CMAKE_CURRENT_SOURCE_DIR}/src/config.h)
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h)
+configure_file (${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-module-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-module-config.h)  # separated from gldi-config.h because it's architecture-dependant (it contains $libdir), so it can't be installed in /usr/include without causing a conflict between 32 and 64 bits packages.
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.pc.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc)
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)

=== Help/data/CMakeLists.txt ===

########### install files ###############

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/Help.conf
	preview.jpg
	icon.svg
	DESTINATION ${helpdatadir})

=== debian/changelog ===
cairo-dock (3.2.0-0ubuntu1) raring; urgency=low

  * New upstream release.
  * Upstream ChangeLog:
    - Enable the Indicator-Generic by default on a Cairo-Dock session under
      Ubuntu
    - Removed the deprecated option 'hide on fullscreen'
    - Task: fixed a bug in cairo_dock_stop_task
    - BSD port: fixed some compilation and linking problems
    - Taskbar: fixed a bug where an icon didn't stop demanding the attention
    - Docks: when changing the alignment of the main dock, correctly update
      the dock
    - Removed the need for pangox (was not used)
    - Drop on container: add URI target before the text target, or we will
      get the link text instead of the link URI in Konqueror (other browsers
      don't have this problem)
    - If an applet crashed the dock when launching it, this applet was
      not blacklisted
    - GUI: fixed a crash in the ModuleWidget class
    - Core: separated gldi-config.h in 2 parts, so that the one that is
      installed doesn't contain any architecture-dependant value
    - po: Imported translations from Launchpad
  * debian/control:
    - Mutter is now better supported by the dock: added on the recommended
      list
  * debian/rules:
    - CMake flag: replaced 'yes' by 'ON'

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Tue, 26 Mar 2013 00:01:34 +0100

=== debian/control ===
--- 
+++ 
@@ -59,7 +59,7 @@
          ${shlibs:Depends}
 Recommends: cairo-dock,
             cairo-dock-plug-ins,
-            compiz-plugins | e17 | kde-window-manager | openbox | xfwm4
+            compiz-plugins | e17 | kde-window-manager | openbox | xfwm4 | mutter
 Suggests: compiz-plugins, gnome-session
 Description: Light and eye-candy dock to launch your programs (core package)
  Cairo-Dock is a pretty, light and convenient interface to your desktop,
